public Quaternion quat_mult(Quaternion q1, Quaternion q2) {

  float a = (q1.a*q2.a - q1.b*q2.b - q1.c*q2.c - q1.d*q2.d);
  float b = (q1.a*q2.b + q1.b*q2.a + q1.c*q2.d - q1.d*q2.c);
  float c = (q1.a*q2.c - q1.b*q2.d + q1.c*q2.a + q1.d*q2.b);
  float d = (q1.a*q2.d + q1.b*q2.c - q1.c*q2.b + q1.d*q2.a);
  Quaternion result = new Quaternion(a,b,c,d);
  return result;
}

// Quaternion multiplication without the .a component
public PVector quat_pointmult( Quaternion q1, Quaternion q2) {
  float x = (q1.a*q2.b + q1.b*q2.a + q1.c*q2.d - q1.d*q2.c);
  float y = (q1.a*q2.c - q1.b*q2.d + q1.c*q2.a + q1.d*q2.b);
  float z = (q1.a*q2.d + q1.b*q2.c - q1.c*q2.b + q1.d*q2.a);
  PVector result = new PVector(x,y,z);
  return result;
}


class Quaternion {
  public float a = 0;
  public float b = 0;
  public float c = 0;
  public float d = 1;

  public Quaternion(float aa,float bb,float cc,float dd) {
    this.a = aa;
    this.b = bb;
    this.c = cc;
    this.d = dd;
  }
}
